function [am,rm,pm,sm,m] = maasc(s,M,wc,type)
%initialise
N = length(s); %number of samples
W = length(wc); %number of frequency points
am = zeros(M,W); %matrix of estimated complex amplitudes for each model order
sm = zeros(M,W); %matrix of estimated variance for each model order
rm = zeros(M,W); %matrix of estimated amplitude for each model order
pm = zeros(M,W); %matrix of estimated phase for each model order
lnmp = zeros(M,W); %pmf for the model order for every frequency
mi = 0; %model order counter

%recursive covariance matrix computation
for m=1:M
  mi = mi + 1;
  L=N-m+1;
  %likelihood
  A = exp(-1i*(0:(m-1))'*wc);
  B = exp(-1i*((m-1):(N-1))'*wc);
  X = flipud(hankel(s(1:m),s(m:N)));
  if strcmp(type,'forward') == 1 %forward estimate of the covariance matrix
    C = (X*X')/L;
    iC = (C\eye(m));
    if m == 1
      iRr = 1/(s'*s);
    else
      iRrs = iRr*flipud(s(N-m+2:N));
      iAr = iRr+(iRrs*iRrs')/(1-flipud(s(N-m+2:N))'*iRrs);
      cr = norm(s(m:N))^2;
      br = flipud(hankel(s(1:m-1),s(m-1:N-1)))*conj(s(m:N));
      iMr = 1/real(cr-br'*iAr*br);
      iArbr = iAr*br;
      iArbriMr = iArbr*iMr;
      iRr = [iMr,-iArbriMr';-iArbriMr,iAr+iArbriMr*iArbr'];
    end
    norm(iRr*L-iC);
  else %forward-backward estimate of the covariance matrix
    C = (X*X'+rot90(X*X',2).')/(2*L);
    iC =(C\eye(m));
  end
  tmp = iC*A;
  H = tmp.*kron(ones(m,1),1./sum(conj(A).*tmp,1));
  Y = X.'*conj(H);
  hRh = sum(abs(Y).^2,1)/L;
  am(mi,:) = sum(Y.*B,1)/L;
  yPoy = L*hRh-L*abs(am(mi,:)).^2;
  r11 = C(1,1);
  r1 = C(2:end,1);
  iPhi = conj(iC(2:end,2:end));
  r1A = (conj(A(2:end,:))-(conj(r1)/r11)*ones(1,W));
  detiS = 1/real(det(iPhi)) * (1 + r11*real(sum(conj(r1A).*(iPhi*r1A),1)));
  lnmp(mi,:) = -L*log(hRh)-(m-1)*log(L);
  sm(mi,:) = yPoy/((L-2)*L);
  rm(mi,:) = abs(am(mi,:));
  pm(mi,:) = angle(am(mi,:));
end
mp = exp(lnmp-ones(M,1)*max(lnmp));
m = mp./(ones(M,1)*sum(mp,1));
